package uk.ac.ox.cs.pdq.planner;

import uk.ac.ox.cs.pdq.ConsistencyChecker;
import uk.ac.ox.cs.pdq.InconsistentParametersException;
import uk.ac.ox.cs.pdq.plan.Plan.ControlFlows;

/**
 * Check high-level planner parameters consistency.
 *
 * @author Julien Leblay
 */
public class PlannerConsistencyChecker implements ConsistencyChecker<PlannerParameters> {

	/**
	 * @param p PlannerParameters
	 * @throws InconsistentParametersException
	 * @see uk.ac.ox.cs.pdq.ConsistencyChecker#check(PlannerParameters)
	 */
	@Override
	public void check(PlannerParameters p) throws InconsistentParametersException {
		if (p.getControlFlow() == ControlFlows.TOP_DOWN) {
			throw new InconsistentParametersException("BLACKBOX_DB cost estimation cannot be used with top-down control flow.");
		}
	}
}
