package uk.ac.ox.cs.pdq.planner.dag.cost;

import uk.ac.ox.cs.pdq.cost.estimators.CostEstimator;
import uk.ac.ox.cs.pdq.plan.Cost;
import uk.ac.ox.cs.pdq.plan.DAGPlan;
import uk.ac.ox.cs.pdq.reasoning.Configuration;


/**
 * Configuration cost estimator.
 * Returns the cost of an input configuration.
 * 
 * @author Efthymia Tsamoura 
 *
 */
public interface ConfigurationCostEstimator extends CostEstimator<DAGPlan>{
	/**
	 * 
	 * @param configuration
	 * @return
	 * 		the cost of the input configuration
	 */
	Cost cost(Configuration configuration);
	
	/**
	 * 
	 * @param configuration
	 * @return
	 * 		the cost of the input configuration
	 */
	Cost estimateCost(Configuration configuration);
	
	ConfigurationCostEstimator clone();
}
