package uk.ac.ox.cs.pdq.planner.dag.cost;

import org.apache.log4j.Logger;

import uk.ac.ox.cs.pdq.cost.estimators.PerInputCostEstimator;
import uk.ac.ox.cs.pdq.logging.performance.StatisticsCollector;
import uk.ac.ox.cs.pdq.plan.DAGPlan;
import uk.ac.ox.cs.pdq.plan.DoubleCost;
import uk.ac.ox.cs.pdq.reasoning.Configuration;

import com.google.common.eventbus.EventBus;


/**
 * 
 * @author Efthymia Tsamoura
 *
 */
public final class ConfigurationPerInputCostEstimator extends PerInputCostEstimator<DAGPlan> implements ConfigurationCostEstimator {
	
	private static Logger log = Logger.getLogger(ConfigurationPerInputCostEstimator.class);
	
	/**
	 * Default constructor
	 * @param eventBus
	 * @param collectStats
	 */
	public ConfigurationPerInputCostEstimator(EventBus eventBus, boolean collectStats) {
		super(eventBus, collectStats);
	}
	
	/**
	 * Constructor
	 * @param stats
	 */
	private ConfigurationPerInputCostEstimator(StatisticsCollector stats) {
		super(stats);
	}
	
	/*
	 * (non-Javadoc)
	 * @see java.lang.Object#clone()
	 */
	@Override
	public ConfigurationPerInputCostEstimator clone() {
		return new ConfigurationPerInputCostEstimator(this.stats.clone());
	}

	@Override
	public DoubleCost cost(Configuration configuration) {
		return super.cost((DAGPlan) configuration.getPlan());
	}

	@Override
	public DoubleCost estimateCost(Configuration configuration) {
		return super.estimateCost((DAGPlan) configuration.getPlan());
	}
}
