package uk.ac.ox.cs.pdq.planner.dag.cost;

import org.apache.log4j.Logger;

import uk.ac.ox.cs.pdq.cost.estimators.TotalResponseTimeCostEstimator;
import uk.ac.ox.cs.pdq.cost.statistics.Catalog;
import uk.ac.ox.cs.pdq.logging.performance.StatisticsCollector;
import uk.ac.ox.cs.pdq.plan.DAGPlan;
import uk.ac.ox.cs.pdq.plan.DoubleCost;
import uk.ac.ox.cs.pdq.reasoning.Configuration;

import com.google.common.eventbus.EventBus;


/**
 * 
 * @author Efthymia Tsamoura
 *
 */
public final class ConfigurationTotalResponeTimeCostEstimator extends TotalResponseTimeCostEstimator<DAGPlan> implements ConfigurationCostEstimator {
	
	private static Logger log = Logger.getLogger(ConfigurationTotalResponeTimeCostEstimator.class);
	
	/**
	 * Default constructor
	 * @param eventBus
	 * @param collectStats
	 */
	public ConfigurationTotalResponeTimeCostEstimator(EventBus eventBus, boolean collectStats, Catalog catalog) {
		super(eventBus, collectStats, catalog);
	}
	
	/**
	 * Constructor
	 * @param stats
	 */
	private ConfigurationTotalResponeTimeCostEstimator(StatisticsCollector stats, Catalog catalog) {
		super(stats, catalog);
	}
	
	/*
	 * (non-Javadoc)
	 * @see java.lang.Object#clone()
	 */
	@Override
	public ConfigurationTotalResponeTimeCostEstimator clone() {
		return new ConfigurationTotalResponeTimeCostEstimator(this.stats.clone(), this.catalog.clone());
	}

	@Override
	public DoubleCost cost(Configuration configuration) {
		return super.cost((DAGPlan) configuration.getPlan());
	}

	@Override
	public DoubleCost estimateCost(Configuration configuration) {
		return super.estimateCost((DAGPlan) configuration.getPlan());
	}
}
