package uk.ac.ox.cs.pdq.planner.homomorphism;

import java.util.Collection;
import java.util.List;
import java.util.Map;

import uk.ac.ox.cs.pdq.fol.Evaluatable;
import uk.ac.ox.cs.pdq.planner.PlannerException;
import uk.ac.ox.cs.pdq.reasoning.Match;

/**
 * Top level interface for detecting homomorphisms.
 *
 * @author Julien Leblay
 *
 */
public interface HomomorphismDetector extends AutoCloseable {

	
	/**
	 * 
	 * @param q
	 * @param constraint
	 * @return matches for input query q that satisfy the input constraint
	 */
	<Q extends Evaluatable> List<Match> getMatches(Q q, HomomorphismConstraint... constraint);

	/**
	 * 
	 * @param q
	 * @param constraint
	 * @return matches for input queries q that satisfy the input constraint
	 */
	<Q extends Evaluatable> Map<Q, List<Match>> getMatches(Collection<Q> q, HomomorphismConstraint... constraint);

	/**
	 * @return HomomorphismDetector
	 */
	HomomorphismDetector clone();
}
