package uk.ac.ox.cs.pdq.planner.homomorphism;

import java.util.Collection;

import uk.ac.ox.cs.pdq.fol.Evaluatable;
import uk.ac.ox.cs.pdq.fol.PredicateFormula;

/**
 * Extends the HomomorphismManager interface by providing a way to add facts.
 *
 * @author Julien Leblay
 */
public interface HomomorphismManager extends HomomorphismDetector {

	/**
	 * Stores the facts of the atoms list in the database
	 * @param atoms Input list of facts
	 */
	void addFacts(Collection<? extends PredicateFormula> atoms);

	/**
	 * Initialises the manager.
	 */
	void initialize();

	/**
	 * Initialises the manager with queries that will be later used.
	 * @param queries
	 */
	void initialize(Collection<Evaluatable> queries);
}
