package uk.ac.ox.cs.pdq.planner.linear.cost;

import uk.ac.ox.cs.pdq.cost.estimators.CostEstimator;
import uk.ac.ox.cs.pdq.plan.Plan;
import uk.ac.ox.cs.pdq.planner.linear.node.SearchNode;

/**
 * Property of a cost model to be propagated across node of a search space.
 *
 * @author Julien Leblay
 */
public interface Propagatable<P extends Plan> extends CostEstimator<P> {
	/**
	 * @return CostPropagator<P,T>
	 */
	<T extends SearchNode> CostPropagator<P, T> getPropagator();
}
