package uk.ac.ox.cs.pdq.test.runtime.util;

import java.io.PrintStream;

import org.apache.log4j.Logger;

import uk.ac.ox.cs.pdq.runtime.Runtime;
import uk.ac.ox.cs.pdq.util.Tuple;

import com.google.common.eventbus.Subscribe;

/**
 * 
 * @author Julien Leblay
 */
public class TupleCounterTest {

	/** Runner's logger. */
	private static Logger log = Logger.getLogger(Runtime.class);

	/** PrintStream where to print tuples. */
	private final PrintStream out;

	private long count = 0;
	
	/**
	 * Default constructor
	 * @param out
	 */
	public TupleCounterTest(PrintStream out) {
		this.out = out;
	}
	
	/**
	 * Empty constructor, causes the tuple to be printed to log.info.
	 */
	public TupleCounterTest() {
		this(null);
	}

	/**
	 * Counts the given tuple.
	 * @param tuple
	 */
	@Subscribe
	public void count(Tuple tuple) {
		this.count++;
	}
	
	public void reset() {
		this.count = 0;
	}
	
	public void report() {
		String message = "Tuple count: " + this.count;
		if (this.out != null) {
			this.out.println(message);
		} else {
			log.info(message);
		}
	}
}
